"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var webp_js_1 = require("../libwebp/dist/webp.cjs.js");
var load_binary_data_js_1 = require("./load-binary-data.js");
var detect_webp_support_js_1 = require("./detect-webp-support.js");
var webpQueue_js_1 = require("./webpQueue.js");
var relax = function () { return new Promise(function (resolve) { return requestAnimationFrame(resolve); }); };
var queue = new webpQueue_js_1.WebpQueue();
var WebpMachineError = /** @class */ (function (_super) {
    __extends(WebpMachineError, _super);
    function WebpMachineError() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return WebpMachineError;
}(Error));
exports.WebpMachineError = WebpMachineError;
exports.defaultDetectWebpImage = function (image) {
    return /\.webp.*$/i.test(image.src) || (image.dataset && /\.webp.*$/i.test(image.dataset.src));
};
exports.defaultDetectWebpBackground = function (el) {
    return /\.webp.*$/i.test(el.style.backgroundImage) || (el.dataset && /\.webp.*$/i.test(el.dataset.bg));
};
/**
 * Webp Machine
 * - decode and polyfill webp images
 * - can only decode images one-at-a-time (otherwise will throw busy error)
 */
var WebpMachine = /** @class */ (function () {
    function WebpMachine(_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.webp, webp = _c === void 0 ? new webp_js_1.Webp() : _c, _d = _b.webpSupport, webpSupport = _d === void 0 ? detect_webp_support_js_1.detectWebpSupport() : _d, _e = _b.detectWebpImage, detectWebpImage = _e === void 0 ? exports.defaultDetectWebpImage : _e, _f = _b.detectWebpBackground, detectWebpBackground = _f === void 0 ? exports.defaultDetectWebpBackground : _f;
        this.processing = false;
        this.busy = false;
        this.cache = {};
        this.processing = false;
        this.busy = false;
        this.cache = {};
        this.webp = webp;
        this.webp.Module['doNotCaptureKeyboard'] = true;
        this.webpSupport = webpSupport;
        this.detectWebpImage = detectWebpImage;
        this.detectWebpBackground = detectWebpBackground;
    }
    /**
     * Decode raw webp data into a png data url
     */
    WebpMachine.prototype.decode = function (webpData) {
        return __awaiter(this, void 0, void 0, function () {
            var canvas, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.busy)
                            throw new WebpMachineError("cannot decode when already busy");
                        this.busy = true;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, relax()];
                    case 2:
                        _a.sent();
                        canvas = document.createElement("canvas");
                        this.webp.setCanvas(canvas);
                        this.webp.webpToSdl(webpData, webpData.length);
                        this.busy = false;
                        return [2 /*return*/, canvas.toDataURL()];
                    case 3:
                        error_1 = _a.sent();
                        this.busy = false;
                        error_1.name = WebpMachineError.name;
                        error_1.message = "failed to decode webp image: " + error_1.message;
                        throw error_1;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Polyfill the webp format on the given <img> element
     */
    WebpMachine.prototype.polyfillImage = function (image) {
        return __awaiter(this, void 0, void 0, function () {
            var src, dataset, dataSrc, img, webpData, pngData, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.webpSupport];
                    case 1:
                        if (_a.sent())
                            return [2 /*return*/];
                        src = image.src, dataset = image.dataset;
                        dataSrc = null;
                        if (!this.detectWebpImage(image)) return [3 /*break*/, 6];
                        if (dataset && dataset.src)
                            dataSrc = dataset.src;
                        img = dataSrc || src;
                        if (this.cache[img]) {
                            image.src = this.cache[img];
                            return [2 /*return*/];
                        }
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 5, , 6]);
                        return [4 /*yield*/, load_binary_data_js_1.loadBinaryData(img)];
                    case 3:
                        webpData = _a.sent();
                        return [4 /*yield*/, this.decode(webpData)];
                    case 4:
                        pngData = _a.sent();
                        image.src = this.cache[img] = pngData;
                        delete image.dataset.src;
                        return [3 /*break*/, 6];
                    case 5:
                        error_2 = _a.sent();
                        error_2.name = WebpMachineError.name;
                        error_2.message = "failed to polyfill image \"" + img + "\": " + error_2.message;
                        throw error_2;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Polyfill the webp format on the given <div> element
     */
    WebpMachine.prototype.polyfillBackground = function (el) {
        return __awaiter(this, void 0, void 0, function () {
            var backgroundImage, dataset, bg, image, webpData, pngData, error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.webpSupport];
                    case 1:
                        if (_a.sent())
                            return [2 /*return*/];
                        backgroundImage = el.style.backgroundImage, dataset = el.dataset;
                        bg = null;
                        if (!this.detectWebpBackground(el)) return [3 /*break*/, 6];
                        if (dataset && dataset.bg)
                            bg = dataset.bg;
                        image = (/([\w\/]+\.\w+)/gi.exec(backgroundImage) || /([\w\/]+\.\w+)/gi.exec(bg))[0];
                        if (this.cache[image]) {
                            el.style.backgroundImage = "url(\"" + this.cache[image] + "\")";
                            return [2 /*return*/];
                        }
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 5, , 6]);
                        return [4 /*yield*/, load_binary_data_js_1.loadBinaryData(image)];
                    case 3:
                        webpData = _a.sent();
                        return [4 /*yield*/, this.decode(webpData)];
                    case 4:
                        pngData = _a.sent();
                        this.cache[image] = pngData;
                        el.style.backgroundImage = "url(\"" + pngData + "\")";
                        delete el.dataset.bg;
                        return [3 /*break*/, 6];
                    case 5:
                        error_3 = _a.sent();
                        error_3.name = WebpMachineError.name;
                        error_3.message = "failed to polyfill image \"" + image + "\": " + error_3.message;
                        throw error_3;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Polyfill webp format on the entire web page
     */
    WebpMachine.prototype.polyfillDocument = function (_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.document, document = _c === void 0 ? window.document : _c, _d = _b.selectors, selectors = _d === void 0 ? "img" : _d;
        return __awaiter(this, void 0, void 0, function () {
            var image, error_4;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0: return [4 /*yield*/, this.webpSupport];
                    case 1:
                        if (_e.sent())
                            return [2 /*return*/, null];
                        queue.enqueue(Array.from(document.querySelectorAll(selectors)));
                        if (this.processing)
                            return [2 /*return*/, null];
                        this.processing = true;
                        _e.label = 2;
                    case 2:
                        if (!(image = queue.dequeue())) return [3 /*break*/, 10];
                        _e.label = 3;
                    case 3:
                        _e.trys.push([3, 8, , 9]);
                        if (!(image instanceof HTMLImageElement)) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.polyfillImage(image)];
                    case 4:
                        _e.sent();
                        return [3 /*break*/, 7];
                    case 5: return [4 /*yield*/, this.polyfillBackground(image)];
                    case 6:
                        _e.sent();
                        _e.label = 7;
                    case 7: return [3 /*break*/, 9];
                    case 8:
                        error_4 = _e.sent();
                        this.processing = false;
                        error_4.name = WebpMachineError.name;
                        error_4.message = "webp el polyfill failed for url \"" + (image instanceof HTMLImageElement ? image.src : null) + "\": " + error_4;
                        throw error_4;
                    case 9: return [3 /*break*/, 2];
                    case 10:
                        this.processing = false;
                        return [2 /*return*/];
                }
            });
        });
    };
    return WebpMachine;
}());
exports.WebpMachine = WebpMachine;
//# sourceMappingURL=webp-machine.js.map